clear all; close all; addpaths; 

for i = 1%:100
% Genenrate example
% Notice that L has to be set as (the length of target - 1) <- IMPORTANT
pickEx = 5; % pickEx=1~8 for #examples
[s1, s2, B, L, T, nRes, gt] = getExample(pickEx); 

% split s1,s2
nSeq = 3;
subSeq1 = splitSeq(s1,nSeq,T);
subSeq2 = splitSeq(s2,nSeq,T);

%% Setup options
opt.dist      = 'l1'; % distance metric ('l1','l2','X2','int');
opt.maxIter   = 1e6;  % max iteration for TCD
opt.nRes      = nRes; % max number of discoveries
opt.isVerbose = 1;    % verbose or not

tRlist = cell(nSeq,1);
info = cell(nSeq,1);
S1 = [];S2 = [];
for i = 1:nSeq
    [tS1, tS2] = initSoft(s1(:,subSeq1(i,1):subSeq1(i,2)), ...
        s2(:,subSeq2(i,1):subSeq2(i,2)), B);
    [tRlist{i},info{i}] = usd(tS1,tS2,L,T,opt);   
    S1 = [S1,tS1]; S2 = [S2,tS2];
end



% Rlist
[Rlist,bd,info] = resortRlist(tRlist, info,subSeq1, subSeq2);
printTmpResult(Rlist,bd,gt,subSeq1,info);
return


%% Get init indices using k-means
%[S1, S2] = initSoft(s1, s2, B); % note that the len(S1)=len(s1)+1

% One may use the hard assignment by [S1, S2] = initHard(s1,s2,B); 
% However be aware that the results are expected to be unsatisfactory.



%% Run TCD
% tic
% [R,info] = usd(S1, S2, L, T, opt);
% toc

%% Print result
printResult(S1, S2, Rlist, gt);
% if rtn ~= 1
%     s1
%     s2
%     keyboard;
% end
end