function printResult(S1,S2,Rall,gt)
% Print the groundtruth and our discoveries

fprintf('===============================================\n');
fprintf('+ TCD results\n');
fprintf('===============================================\n');

gt_dist = zeros(size(gt,1),1);
for iGT = 1:size(gt,1)
  curgt = gt(iGT,:);
  fprintf('+ truth(%d):\t[%3d, %3d, %3d, %3d  ]\n',iGT,curgt);
  g1 = S1(:,gt(2)+1) - S1(:,gt(1));
  g2 = S2(:,gt(4)+1) - S2(:,gt(3));
  g1 = g1 / sum(g1);
  g2 = g2 / sum(g2);
  gt_dist(iGT) = sum(abs(g1-g2));
end

for iGT = 1:size(gt,1)
  fprintf('  - |gt(%d)| = %.10f\n', iGT, gt_dist(iGT));
end

for iR = 1:numel(Rall)
  R       = Rall(iR);
  if isempty(R.lo)
    continue;
  end
  hist1   = S1(:,R.lo(2)+1) - S1(:,R.lo(1));
  hist2   = S2(:,R.lo(4)+1) - S2(:,R.lo(3));
  len1    = single(R.lo(2)+1 - R.lo(1));
  len2    = single(R.lo(4)+1 - R.lo(3));
  
%   h1 = hist1/len1;
%   h2 = hist2/len2;
  
  h1 = hist1/sum(hist1);
  h2 = hist2/sum(hist2);
  
  hist1_gt = S1(:,gt(2)+1) - S1(:,gt(1));
  hist2_gt = S2(:,gt(4)+1) - S2(:,gt(3));
%   g1 = hist1_gt / (gt(2)+1 - gt(1));
%   g2 = hist2_gt / (gt(4)+1 - gt(3));
  g1 = hist1_gt / sum(hist1_gt);
  g2 = hist2_gt / sum(hist2_gt);
  
  fprintf('+ TCD  (%d):\t[%3d, %3d, %3d, %3d  ]\n',iR,R.lo);
  fprintf('  - h1 = [%s\b\b]\n', sprintf('%.1f, ',h1));
  fprintf('  - h2 = [%s\b\b]\n', sprintf('%.1f, ',h2));
  fprintf('  - |h1-h2| = %.10f\n', sum(abs(h1-h2)));
    
  if sum(abs(g1-g2)) < sum(abs(h1-h2))
   %   keyboard
  end
  
  % show hist
  figure;
  subplot(1,2,1); h1(6:end) = h1(6:end)*10;
  bar(h1,1); hold on; set(gcf,'position',[ 244   490   653   119]);
  set(gca,'Xlim',[.5,30.5],'ylim',[0,.24]);
  subplot(1,2,2); h2(6:end) = h2(6:end)*10;
  bar(h2,1); hold on; set(gcf,'position',[ 244   490   653   119]);
  set(gca,'Xlim',[.5,30.5],'ylim',[0,.24]);
end
